import React, {Component} from 'react'
import {inject, observer} from "mobx-react"
import css from './index.scss'
import UCInfo from '../UCInfo/index'

@inject('HolidayStore')
@observer
class KaraHoliday extends Component{
  constructor(props) {
    super(props)
    this.state = {
      iconList: [],
      showAll: false
    }
  }
  componentDidMount(){
    let holidayStore = this.props.HolidayStore
    holidayStore.getHolidayList()
  }
  render(){
    const {UCNavStore} = this.props
    return (
      <div className={css.KaraHoliday}>
        <div className={css.holidayItem}>
          <div className='s-info s-bg-holiday'><i className={`kuc-iconfont kuc-fdnj s-reverse`}></i></div>
          <div>
            <span>法定年假（共5.0天）</span>
            <span>可申请:5.0天</span>
            <a className="btn btn-primary medium outline">申请</a>
          </div>
        </div>
        <div>
          <i className={`kuc-iconfont ${this.state.showAll ? 'kuc-double-up' : 'kuc-double-down'}`} onClick={()=>{this.setState({showAll: !this.state.showAll})}}></i>
        </div>
      </div>
    )
  }
}

export default KaraHoliday
