import React, {Component} from 'react'
import {observable, configure} from 'mobx'
import {Provider} from 'mobx-react'
import {Route, Switch} from 'react-router-dom'
import './assets/iconfont/iconfont.css'
import UCNav from './components/UCNav'
import UCNavStore from './stores/UCNavStore'
import UCInfoStore from './stores/UCInfoStore'
import ConfigStore from './stores/ConfigStore'
import IntegralStore from './stores/UCIntegralStore'
import HolidayStore from './stores/UCHolidayStore'
import FavoriteStore from './stores/UCFavoriteStore'

configure({
  enforceActions: true,
  isolateGlobalState: true,
})

class KaraUC extends Component{
  constructor(props){
    super(props)
      if (props.config)
        ConfigStore.setConfig(props.config)
  }

  componentWillReceiveProps(nextProps){
    if (nextProps.config)
      ConfigStore.setConfig(nextProps.config)
  }

  render(){
    return (
      <Provider {...{UCNavStore, UCInfoStore, IntegralStore, ConfigStore, HolidayStore, FavoriteStore}} >
        <Switch>
          <Route exact path={`/uc/UCNav`} component={UCNav} />
          <Route path={`/uc/:type`} component={UCNav} match={this.props.config.match} />
        </Switch>
      </Provider>
      // <Provider {...{UCNavStore, UCInfoStore, UCIntegral, ConfigStore}}>
      //   <UCNav />
      // </Provider>
    )
  }
}

export default KaraUC
